-----------------------------------------------------
-- Beispielskript zur SNEK 3 im Mrz 2014 in Nrnberg
-- Autor: Bernd Jungbluth
-- Keine Gewhrleistung, keine Haftung
-----------------------------------------------------


-- Neue Datenbank fr Clustered Columnstore Index (CCI) anlegen
CREATE DATABASE Demo_CCI
ON  
PRIMARY 
	(NAME = DEMO_CCI, 
	 FILENAME = N'D:\SNEK\Datenbanken\DEMO_CCI.mdf', 
	 SIZE = 500MB , MAXSIZE = UNLIMITED, FILEGROWTH = 1024KB)
 LOG ON 
	(NAME = N'DEMO_CCI_log', 
	 FILENAME = N'D:\SNEK\Datenbanken\DEMO_CCI_log.ldf',
	 SIZE = 500MB , MAXSIZE = 2048GB , FILEGROWTH = 10%);
GO


USE Demo_CCI;
GO


-- Neue Tabelle mit Clustered und Nonclustered Index anlegen
CREATE TABLE dbo.Personen(
	PersonID int Not Null 
			 CONSTRAINT CIX_Personen_PersonID PRIMARY KEY,
	Nachname nvarchar(50) Not Null 
			 INDEX IX_Personen_Nachname,
	Vorname nvarchar(50));
GO

-- 2,7 Millionen Datenstze anfgen
DECLARE @Zaehler As int = 1,
		@MaxWert As int = 1;

SET NOCOUNT ON;

BEGIN TRAN
WHILE @Zaehler <= 2700000
BEGIN
	INSERT INTO dbo.Personen (PersonID, Nachname, Vorname)
		 VALUES (@MaxWert + @Zaehler, 'Name' + LEFT(CAST(@Zaehler As varchar(50)), 1), 'Vorname');
	SET @Zaehler = @Zaehler + 1;
END;
COMMIT;