-----------------------------------------------------
-- Beispielskript zur SNEK 3 im Mrz 2014 in Nrnberg
-- Autor: Bernd Jungbluth
-- Keine Gewhrleistung, keine Haftung
-----------------------------------------------------

USE Demo_CCI;
GO

-- Neue Tabelle fr Clustered Columnstore Index anlegen
SELECT PersonID, Nachname, Vorname INTO dbo.PersonenCCI FROM dbo.Personen;
-- Verbesserte Performance bei SELECT..INTO in SQL Server 2014

-- Gruppierter Columnstore Index anlegen
CREATE CLUSTERED COLUMNSTORE INDEX CCI_PersonenCCI ON dbo.PersonenCCI;
GO

-- Gruppierten Columnstore Index aufbauen
ALTER TABLE dbo.PersonenCCI REBUILD;
GO


-- Performancevergleich
-- Ausgabe Zeitmessung aktivieren
SET STATISTICS TIME ON;

-- Vergleich mit Aggegration 
SELECT Nachname, COUNT(Vorname) As Anzahl FROM dbo.PersonenCCI GROUP BY Nachname;
SELECT Nachname, COUNT(Vorname) As Anzahl FROM dbo.Personen GROUP BY Nachname;

-- Vergleich ohne Aggegration mit WHERE
SELECT Nachname, Vorname FROM dbo.PersonenCCI WHERE Nachname = 'Name1';
SELECT Nachname, Vorname FROM dbo.Personen WHERE Nachname = 'Name1';

