-----------------------------------------------------
-- Beispielskript zur SNEK 3 im Mrz 2014 in Nrnberg
-- Autor: Bernd Jungbluth
-- Keine Gewhrleistung, keine Haftung
-----------------------------------------------------

USE Demo_CCI;
GO

-- CCI-Tabelle lschen und neu anlegen
-- um leere Systemtabellen zu erhalten
DROP TABLE dbo.PersonenCCI;
CREATE TABLE dbo.PersonenCCI(
	PersonID int Not Null,
	Nachname varchar(50) Not Null,
	Vorname varchar(50));
GO
-- Gruppierter Columnstore Index anlegen
CREATE CLUSTERED COLUMNSTORE INDEX CCI_PersonenCCI ON dbo.PersonenCCI;
GO

-- 1,7 Millionen Datenstze anfgen
DECLARE @Zaehler As int = 0,
		@MaxWert As int = 1;
SET NOCOUNT ON;
BEGIN TRAN
WHILE @Zaehler <= 1700000
BEGIN
	INSERT INTO dbo.PersonenCCI (PersonID, Nachname, Vorname)
		 VALUES (@MaxWert + @Zaehler, 'Name' + LEFT(CAST(@Zaehler As varchar(50)), 1), 'Vorname');
	SET @Zaehler = @Zaehler + 1;
END;
COMMIT;

-- Wie ist die Verteilung der Zeilengruppen, Segmente und Dictionaries?
SELECT * FROM sys.column_store_row_groups;
SELECT * FROM sys.column_store_segments;
SELECT * FROM sys.column_store_dictionaries;


-- Tuple Mover auslsen
ALTER TABLE dbo.PersonenCCI REBUILD;
GO

-- Wie ist jetzt die Verteilung der Zeilengruppen, Segmente und Dictionaries?
SELECT * FROM sys.column_store_row_groups;
SELECT * FROM sys.column_store_segments;
SELECT * FROM sys.column_store_dictionaries;


-- Weitere 7.000 Datenstze hinzufgen
DECLARE @Zaehler As int = 1,
		@MaxWert As int
SELECT @MaxWert = IsNull(Max(PersonID), 0) FROM dbo.PersonenCCI;
BEGIN TRAN
WHILE @Zaehler <= 7000
BEGIN
	INSERT INTO dbo.PersonenCCI (PersonID, Nachname, Vorname)
		 VALUES (@MaxWert + @Zaehler, 'Name' + CAST(@Zaehler As varchar(50)), 'Vorname');
	SET @Zaehler = @Zaehler + 1;
END;
COMMIT;

-- Wie sehen die Zeilengruppen jetzt aus?
SELECT * FROM sys.column_store_row_groups;

-- Tuple Mover auslsen
ALTER TABLE dbo.PersonenCCI REBUILD;
GO
SELECT * FROM sys.column_store_row_groups;

