-----------------------------------------------------
-- Beispielskript zur SNEK 3 im Mrz 2014 in Nrnberg
-- Autor: Bernd Jungbluth
-- Keine Gewhrleistung, keine Haftung
-----------------------------------------------------

USE DEMO_CCI;
GO

-- Tabelle anlegen
CREATE TABLE dbo.KontakteCCI(
	KontaktID int Not Null,
	Nachname varchar(50) Not Null,
	Vorname varchar(50));
GO
-- Gruppierter Columnstore Index anlegen
CREATE CLUSTERED COLUMNSTORE INDEX CCI_KontakteCCI ON dbo.KontakteCCI;
GO

-- 1 Datensatz hinzufgen
BEGIN TRAN
	INSERT INTO dbo.KontakteCCI (KontaktID, Nachname, Vorname)
		 VALUES (1, 'Donaubauer', 'Karl');

-- Zeilengruppe ausgeben
SELECT	* FROM sys.column_store_row_groups 
WHERE	object_id = Object_Id('dbo.KontakteCCI'); 

-- Sperren anzeigen
SELECT	dm_tran_locks.request_session_id, dm_tran_locks.resource_database_id,
		DB_NAME(dm_tran_locks.resource_database_id) AS dbname,
		CASE 
			WHEN resource_type = 'object'
            THEN OBJECT_NAME(dm_tran_locks.resource_associated_entity_id)
			ELSE OBJECT_NAME(partitions.OBJECT_ID)
		END AS ObjectName,
		partitions.index_id, indexes.name AS index_name, dm_tran_locks.resource_type,
		dm_tran_locks.resource_description, dm_tran_locks.resource_associated_entity_id,
		dm_tran_locks.request_mode, dm_tran_locks.request_status
FROM	sys.dm_tran_locks
		LEFT JOIN sys.partitions 
				ON partitions.hobt_id = dm_tran_locks.resource_associated_entity_id
		INNER JOIN sys.indexes 
				ON indexes.OBJECT_ID = partitions.OBJECT_ID 
			   AND indexes.index_id = partitions.index_id
WHERE	resource_associated_entity_id > 0
		AND 
		resource_database_id = DB_ID()
ORDER BY request_session_id, resource_associated_entity_id; 

-- Abschlieen nicht vergessen
ROLLBACK;
